package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.BaseEnergyStorageDeviceEnt;
import pps.core.base.entity.BaseEnergyStorageDeviceView;
import pps.core.base.mapper.BaseEnergyStorageDeviceMapper;
import pps.core.base.mapper.BaseEnergyStorageDeviceViewMapper;
import pps.core.base.service.data.base_energy_storage_device.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BaseEnergyStorageDeviceService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createBaseEnergyStorageDevice(XContext context, CreateBaseEnergyStorageDeviceInput input) {
        BaseEnergyStorageDeviceMapper mapper = context.getBean(BaseEnergyStorageDeviceMapper.class);
        BaseEnergyStorageDeviceEnt entity = new BaseEnergyStorageDeviceEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateBaseEnergyStorageDevice(XContext context, UpdateBaseEnergyStorageDeviceInput input) {
        BaseEnergyStorageDeviceMapper mapper = context.getBean(BaseEnergyStorageDeviceMapper.class);
        QueryWrapper<BaseEnergyStorageDeviceEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseEnergyStorageDeviceEnt::getId, input.getId());
        BaseEnergyStorageDeviceEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteBaseEnergyStorageDevice(XContext context, DeleteBaseEnergyStorageDeviceInput input) {
        BaseEnergyStorageDeviceMapper mapper = context.getBean(BaseEnergyStorageDeviceMapper.class);
        QueryWrapper<BaseEnergyStorageDeviceEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseEnergyStorageDeviceEnt::getId, input.getId());
        BaseEnergyStorageDeviceEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBaseEnergyStorageDeviceOutput> getBaseEnergyStorageDevice(XContext context, GetBaseEnergyStorageDeviceInput input) {
        BaseEnergyStorageDeviceMapper mapper = context.getBean(BaseEnergyStorageDeviceMapper.class);
        QueryWrapper<BaseEnergyStorageDeviceEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseEnergyStorageDeviceEnt::getId, input.getId());
        BaseEnergyStorageDeviceEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseEnergyStorageDeviceOutput output = new GetBaseEnergyStorageDeviceOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBaseEnergyStorageDeviceOutput> queryBaseEnergyStorageDevice(XContext context, QueryBaseEnergyStorageDeviceInput input) {
        BaseEnergyStorageDeviceMapper mapper = context.getBean(BaseEnergyStorageDeviceMapper.class);
        QueryWrapper<BaseEnergyStorageDeviceEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BaseEnergyStorageDeviceEnt::getId, input.getId())
                .eq(BaseEnergyStorageDeviceEnt::getIsDeleted, input.getIsDeleted())
                .like(BaseEnergyStorageDeviceEnt::getCreateById, input.getCreateById())
                .like(BaseEnergyStorageDeviceEnt::getCreateByName, input.getCreateByName())
                .eq(BaseEnergyStorageDeviceEnt::getCreateTime, input.getCreateTime())
                .like(BaseEnergyStorageDeviceEnt::getModifyById, input.getModifyById())
                .like(BaseEnergyStorageDeviceEnt::getModifyByName, input.getModifyByName())
                .eq(BaseEnergyStorageDeviceEnt::getModifyTime, input.getModifyTime())
                .like(BaseEnergyStorageDeviceEnt::getOuId, input.getOuId())
                .like(BaseEnergyStorageDeviceEnt::getDeviceName, input.getDeviceName())
                .like(BaseEnergyStorageDeviceEnt::getMakerNumber, input.getMakerNumber())
                .like(BaseEnergyStorageDeviceEnt::getStorageModelKey, input.getStorageModelKey())
                .eq(BaseEnergyStorageDeviceEnt::getApparatusCapacity, input.getApparatusCapacity())
                .eq(BaseEnergyStorageDeviceEnt::getRatedDischargePower, input.getRatedDischargePower())
                .eq(BaseEnergyStorageDeviceEnt::getRatedChargingPower, input.getRatedChargingPower());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBaseEnergyStorageDeviceOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBaseEnergyStorageDeviceOutput> dynamicQueryBaseEnergyStorageDevice(XContext context, CustomQueryInput input) {
        BaseEnergyStorageDeviceMapper mapper = context.getBean(BaseEnergyStorageDeviceMapper.class);
        return XMapperHelper.query(mapper, input, BaseEnergyStorageDeviceEnt.class, QueryBaseEnergyStorageDeviceOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBaseEnergyStorageDeviceViewOutput> getBaseEnergyStorageDeviceView(XContext context, GetBaseEnergyStorageDeviceViewInput input) {
        BaseEnergyStorageDeviceViewMapper mapper = context.getBean(BaseEnergyStorageDeviceViewMapper.class);
        BaseEnergyStorageDeviceView record = new BaseEnergyStorageDeviceView();
        XCopyUtils.copyObject(input, record);
        BaseEnergyStorageDeviceView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseEnergyStorageDeviceViewOutput output = new GetBaseEnergyStorageDeviceViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBaseEnergyStorageDeviceViewOutput> queryBaseEnergyStorageDeviceView(XContext context, QueryBaseEnergyStorageDeviceViewInput input) {
        BaseEnergyStorageDeviceViewMapper mapper = context.getBean(BaseEnergyStorageDeviceViewMapper.class);
        BaseEnergyStorageDeviceView record = new BaseEnergyStorageDeviceView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BaseEnergyStorageDeviceView> list = mapper.selectList(record);
        PageInfo<BaseEnergyStorageDeviceView> pageInfo = new PageInfo<>(list);
        List<QueryBaseEnergyStorageDeviceViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBaseEnergyStorageDeviceViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
