package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.BasePhotovoltaicPlantEnt;
import pps.core.base.entity.BasePhotovoltaicPlantView;
import pps.core.base.mapper.BasePhotovoltaicPlantMapper;
import pps.core.base.mapper.BasePhotovoltaicPlantViewMapper;
import pps.core.base.service.data.base_photovoltaic_plant.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BasePhotovoltaicPlantService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createBasePhotovoltaicPlant(XContext context, CreateBasePhotovoltaicPlantInput input) {
        BasePhotovoltaicPlantMapper mapper = context.getBean(BasePhotovoltaicPlantMapper.class);
        BasePhotovoltaicPlantEnt entity = new BasePhotovoltaicPlantEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateBasePhotovoltaicPlant(XContext context, UpdateBasePhotovoltaicPlantInput input) {
        BasePhotovoltaicPlantMapper mapper = context.getBean(BasePhotovoltaicPlantMapper.class);
        QueryWrapper<BasePhotovoltaicPlantEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePhotovoltaicPlantEnt::getId, input.getId());
        BasePhotovoltaicPlantEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteBasePhotovoltaicPlant(XContext context, DeleteBasePhotovoltaicPlantInput input) {
        BasePhotovoltaicPlantMapper mapper = context.getBean(BasePhotovoltaicPlantMapper.class);
        QueryWrapper<BasePhotovoltaicPlantEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePhotovoltaicPlantEnt::getId, input.getId());
        BasePhotovoltaicPlantEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePhotovoltaicPlantOutput> getBasePhotovoltaicPlant(XContext context, GetBasePhotovoltaicPlantInput input) {
        BasePhotovoltaicPlantMapper mapper = context.getBean(BasePhotovoltaicPlantMapper.class);
        QueryWrapper<BasePhotovoltaicPlantEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePhotovoltaicPlantEnt::getId, input.getId());
        BasePhotovoltaicPlantEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePhotovoltaicPlantOutput output = new GetBasePhotovoltaicPlantOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePhotovoltaicPlantOutput> queryBasePhotovoltaicPlant(XContext context, QueryBasePhotovoltaicPlantInput input) {
        BasePhotovoltaicPlantMapper mapper = context.getBean(BasePhotovoltaicPlantMapper.class);
        QueryWrapper<BasePhotovoltaicPlantEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BasePhotovoltaicPlantEnt::getId, input.getId())
                .eq(BasePhotovoltaicPlantEnt::getIsDeleted, input.getIsDeleted())
                .like(BasePhotovoltaicPlantEnt::getCreateById, input.getCreateById())
                .like(BasePhotovoltaicPlantEnt::getCreateByName, input.getCreateByName())
                .eq(BasePhotovoltaicPlantEnt::getCreateTime, input.getCreateTime())
                .like(BasePhotovoltaicPlantEnt::getModifyById, input.getModifyById())
                .like(BasePhotovoltaicPlantEnt::getModifyByName, input.getModifyByName())
                .eq(BasePhotovoltaicPlantEnt::getModifyTime, input.getModifyTime())
                .like(BasePhotovoltaicPlantEnt::getOuId, input.getOuId())
                .like(BasePhotovoltaicPlantEnt::getStationName, input.getStationName())
                .like(BasePhotovoltaicPlantEnt::getMakerNumber, input.getMakerNumber())
                .like(BasePhotovoltaicPlantEnt::getPhotovoltaicModelKey, input.getPhotovoltaicModelKey())
                .eq(BasePhotovoltaicPlantEnt::getMountingAngle, input.getMountingAngle())
                .eq(BasePhotovoltaicPlantEnt::getTotalPower, input.getTotalPower())
                .eq(BasePhotovoltaicPlantEnt::getArrayOrientation, input.getArrayOrientation());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBasePhotovoltaicPlantOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePhotovoltaicPlantOutput> dynamicQueryBasePhotovoltaicPlant(XContext context, CustomQueryInput input) {
        BasePhotovoltaicPlantMapper mapper = context.getBean(BasePhotovoltaicPlantMapper.class);
        return XMapperHelper.query(mapper, input, BasePhotovoltaicPlantEnt.class, QueryBasePhotovoltaicPlantOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePhotovoltaicPlantViewOutput> getBasePhotovoltaicPlantView(XContext context, GetBasePhotovoltaicPlantViewInput input) {
        BasePhotovoltaicPlantViewMapper mapper = context.getBean(BasePhotovoltaicPlantViewMapper.class);
        BasePhotovoltaicPlantView record = new BasePhotovoltaicPlantView();
        XCopyUtils.copyObject(input, record);
        BasePhotovoltaicPlantView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePhotovoltaicPlantViewOutput output = new GetBasePhotovoltaicPlantViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePhotovoltaicPlantViewOutput> queryBasePhotovoltaicPlantView(XContext context, QueryBasePhotovoltaicPlantViewInput input) {
        BasePhotovoltaicPlantViewMapper mapper = context.getBean(BasePhotovoltaicPlantViewMapper.class);
        BasePhotovoltaicPlantView record = new BasePhotovoltaicPlantView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BasePhotovoltaicPlantView> list = mapper.selectList(record);
        PageInfo<BasePhotovoltaicPlantView> pageInfo = new PageInfo<>(list);
        List<QueryBasePhotovoltaicPlantViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBasePhotovoltaicPlantViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
