package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.BasePowerLineWellheadEnt;
import pps.core.base.entity.BasePowerLineWellheadView;
import pps.core.base.mapper.BasePowerLineWellheadMapper;
import pps.core.base.mapper.BasePowerLineWellheadViewMapper;
import pps.core.base.service.data.base_power_line_wellhead.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BasePowerLineWellheadService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createBasePowerLineWellhead(XContext context, CreateBasePowerLineWellheadInput input) {
        BasePowerLineWellheadMapper mapper = context.getBean(BasePowerLineWellheadMapper.class);
        BasePowerLineWellheadEnt entity = new BasePowerLineWellheadEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateBasePowerLineWellhead(XContext context, UpdateBasePowerLineWellheadInput input) {
        BasePowerLineWellheadMapper mapper = context.getBean(BasePowerLineWellheadMapper.class);
        QueryWrapper<BasePowerLineWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePowerLineWellheadEnt::getId, input.getId());
        BasePowerLineWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteBasePowerLineWellhead(XContext context, DeleteBasePowerLineWellheadInput input) {
        BasePowerLineWellheadMapper mapper = context.getBean(BasePowerLineWellheadMapper.class);
        QueryWrapper<BasePowerLineWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePowerLineWellheadEnt::getId, input.getId());
        BasePowerLineWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePowerLineWellheadOutput> getBasePowerLineWellhead(XContext context, GetBasePowerLineWellheadInput input) {
        BasePowerLineWellheadMapper mapper = context.getBean(BasePowerLineWellheadMapper.class);
        QueryWrapper<BasePowerLineWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePowerLineWellheadEnt::getId, input.getId());
        BasePowerLineWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePowerLineWellheadOutput output = new GetBasePowerLineWellheadOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePowerLineWellheadOutput> queryBasePowerLineWellhead(XContext context, QueryBasePowerLineWellheadInput input) {
        BasePowerLineWellheadMapper mapper = context.getBean(BasePowerLineWellheadMapper.class);
        QueryWrapper<BasePowerLineWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BasePowerLineWellheadEnt::getId, input.getId())
                .eq(BasePowerLineWellheadEnt::getIsDeleted, input.getIsDeleted())
                .like(BasePowerLineWellheadEnt::getCreateById, input.getCreateById())
                .like(BasePowerLineWellheadEnt::getCreateByName, input.getCreateByName())
                .eq(BasePowerLineWellheadEnt::getCreateTime, input.getCreateTime())
                .like(BasePowerLineWellheadEnt::getModifyById, input.getModifyById())
                .like(BasePowerLineWellheadEnt::getModifyByName, input.getModifyByName())
                .eq(BasePowerLineWellheadEnt::getModifyTime, input.getModifyTime())
                .like(BasePowerLineWellheadEnt::getLineId, input.getLineId())
                .like(BasePowerLineWellheadEnt::getWellheadId, input.getWellheadId());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBasePowerLineWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePowerLineWellheadOutput> dynamicQueryBasePowerLineWellhead(XContext context, CustomQueryInput input) {
        BasePowerLineWellheadMapper mapper = context.getBean(BasePowerLineWellheadMapper.class);
        return XMapperHelper.query(mapper, input, BasePowerLineWellheadEnt.class, QueryBasePowerLineWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePowerLineWellheadViewOutput> getBasePowerLineWellheadView(XContext context, GetBasePowerLineWellheadViewInput input) {
        BasePowerLineWellheadViewMapper mapper = context.getBean(BasePowerLineWellheadViewMapper.class);
        BasePowerLineWellheadView record = new BasePowerLineWellheadView();
        XCopyUtils.copyObject(input, record);
        BasePowerLineWellheadView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePowerLineWellheadViewOutput output = new GetBasePowerLineWellheadViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePowerLineWellheadViewOutput> queryBasePowerLineWellheadView(XContext context, QueryBasePowerLineWellheadViewInput input) {
        BasePowerLineWellheadViewMapper mapper = context.getBean(BasePowerLineWellheadViewMapper.class);
        BasePowerLineWellheadView record = new BasePowerLineWellheadView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BasePowerLineWellheadView> list = mapper.selectList(record);
        PageInfo<BasePowerLineWellheadView> pageInfo = new PageInfo<>(list);
        List<QueryBasePowerLineWellheadViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBasePowerLineWellheadViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
